#!/usr/bin/env python
# Copyright (C) 2001 Aaron Lav, asl2@pobox.com

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


import readline
import munge_readline

munge_readline.word_break("")
class URLCompleter:
    def __init__ (self,urllist):
	self._urllist = urllist
	self._matchlist = [];
        readline.set_completer(self.complete)
	
    def calc_matches(self,text):
	matchlist = [];
	n = len(text)
	for url in self._urllist:
	    if url[:n] == text:
		matchlist.append(url)
	return matchlist
# remember, the complete method runs inside a readline() callback,
# and thus its exceptions are swallowed.

    def complete (self, text, state):
	if state == 0:
	    self._matchlist = self.calc_matches (text)
	try:
	    return self._matchlist[state]
	except IndexError:
	    return None

if __name__ == '__main__':
    URLCompleter(["http://www.foo.example","http://foo.example",
                  "http://www.foo.example/bar.html"])
    while 1:
        tmp = raw_input ()
    
